# MGCNN
This repository contains the code and data used to produce the results in A. Peel et al. (2018), [arXiv:1810.11030][arXiv].

The Convolutional Neural Network (CNN) is implemented in Keras using TensorFlow as backend. As the DUSTGRAIN-pathfinder simulations are not yet public, we do not include the original convergence maps derived from the simulations. We provide instead the wavelet PDF datacubes for each of the four cosmological models studied (one LCDM and three modified gravity f(R) models) as described in the paper.

## Requirements
- Python 3
- numpy
- Keras with TensorFlow backend
- scikit-learn

## Usage
```sh
python3 train_cnn.py -n0
```
The three options for the noise flag "-n" are (0, 1, 2), which correspond to noise standard deviations of sigma = (0, 0.35, 0.70) added to the original convergence maps.

Additional flags are "-i" and "-e" for the number of training iterations and epochs, respectively.

## Reference
Title: [Distinguishing standard and modified gravity cosmologies with machine learning][arXiv]\
Authors: Austin Peel, Florian Lalande, Jean-Luc Starck, Valeria Pettorino, Julian Merten, Carlo Giocoli, Massimo Meneghetti, Marco Baldi\
Year: 2018

[arXiv]: https://arxiv.org/abs/1810.11030
